// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "MultiScreen.h"

#include "MainFrm.h"
#include "Doc.h"
#include "Doc2.h"
#include "View1.h"
#include "View5.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_COMMAND(IDM_VIEW1, &CMainFrame::OnView1)
	ON_COMMAND(IDM_VIEW5, &CMainFrame::OnView5)
	ON_UPDATE_COMMAND_UI(IDM_VIEW1, &CMainFrame::OnUpdateView1)
	ON_UPDATE_COMMAND_UI(IDM_VIEW5, &CMainFrame::OnUpdateView5)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};


// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

//---------------------------------------------------------------
//	Desc:	Switches out the current view with a new view and eliminate the old view
//	Params:	A paramater to indicate what view to switch in can be anything you wish
//	returns:
//---------------------------------------------------------------

void CMainFrame::SwitchToView(int nView)
{
  CView* pOldActiveView = GetActiveView();	// save old view
  CView* pNewActiveView;

  CDocument * pOldActiveDocument;			// ?? how to use these appropriately
  CRichEditDoc * pNewActiveDocument;		// to match the views up with the documents

  CDocument* pDoc = GetActiveDocument();



  switch(nView)
  {
	case 1:
	  pNewActiveView = (CView*)new CView1;
	break;
	case 5:
	  pNewActiveView = (CView*)new CView5;
	break;
  }

  pNewActiveView->Create(NULL, NULL, AFX_WS_DEFAULT_VIEW,
	      rectDefault, this, AFX_IDW_PANE_FIRST, NULL);

  // Show the newly active view and hide the inactive view.
  pNewActiveView->ShowWindow(SW_SHOW);  // show the new window
  pOldActiveView->ShowWindow(SW_HIDE);  // hide the old

  // Connect the newly active view to the document, and
  // disconnect the inactive view.
  pDoc->AddView(pNewActiveView);
  pDoc->RemoveView(pOldActiveView);

  SetActiveView(pNewActiveView);	// change the active view
  pNewActiveView->OnInitialUpdate();	  
  RecalcLayout();			 // adjust frame
  delete pOldActiveView;		 // delete old view

}// SwitchToView(int nView)


void CMainFrame::OnView1()
{
	 SwitchToView(1);
}

void CMainFrame::OnView5()
{
	 SwitchToView(5);
}

void CMainFrame::OnUpdateView1(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(GetActiveView()->GetRuntimeClass()!=RUNTIME_CLASS(CView1));
}

void CMainFrame::OnUpdateView5(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(GetActiveView()->GetRuntimeClass()!=RUNTIME_CLASS(CView5));
}
